/*-
 * $Id: rr-message-startrpy.h,v 1.4 2003/02/05 09:03:26 jonas Exp $
 *
 * See the file LICENSE for redistribution information. 
 * If you have not received a copy of the license, please contact CodeFactory
 * by email at info@codefactory.se, or on the web at http://www.codefactory.se/
 * You may also write to: CodeFactory AB, SE-903 47, Ume, Sweden.
 *
 * Copyright (c) 2002, 2003 Jonas Borgstrm <jonas@codefactory.se>
 * Copyright (c) 2002, 2003 Daniel Lundin   <daniel@codefactory.se>
 * Copyright (c) 2002, 2003 CodeFactory AB.  All rights reserved.
 */

#ifndef __RR_MESSAGE_STARTRPY_H__
#define __RR_MESSAGE_STARTRPY_H__

typedef struct _RRMessageStartRpy RRMessageStartRpy;
typedef struct _RRMessageStartRpyPriv RRMessageStartRpyPriv;
typedef struct _RRMessageStartRpyClass RRMessageStartRpyClass;

#include <librr/rr-frame.h>
#include <librr/message/rr-message.h>

G_BEGIN_DECLS

#define RR_TYPE_MESSAGE_STARTRPY (rr_message_startrpy_get_type ())
#define RR_MESSAGE_STARTRPY(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), RR_TYPE_MESSAGE_STARTRPY, RRMessageStartRpy))
#define RR_MESSAGE_STARTRPY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RR_TYPE_MESSAGE_STARTRPY, RRMessageStartRpyClass))
#define RR_IS_MESSAGE_STARTRPY(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), RR_TYPE_MESSAGE_STARTRPY))
#define RR_IS_MESSAGE_STARTRPY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RR_TYPE_MESSAGE_STARTRPY))
#define RR_MESSAGE_STARTRPY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RR_TYPE_MESSAGE_STARTRPY, RRMessageStartRpyClass))

struct _RRMessageStartRpy {
	RRMessage parent_object;
	RRMessageStartRpyPriv *priv;
};

struct _RRMessageStartRpyClass {
	RRMessageClass parent_class;
};

GType rr_message_startrpy_get_type (void);

RRMessageStartRpy *rr_message_startrpy_new     (const gchar *uri,
						const gchar *piggyback,
						RRChannel *channel_to_activate);

const gchar       *rr_message_startrpy_get_uri       (RRMessageStartRpy *rpy);
const gchar       *rr_message_startrpy_get_piggyback (RRMessageStartRpy *rpy);

G_END_DECLS

#endif /* __RR_MESSAGE_STARTRPY_H__ */
