/*-
 * $Id: rr-message.h,v 1.14 2003/02/05 09:03:26 jonas Exp $
 *
 * See the file LICENSE for redistribution information. 
 * If you have not received a copy of the license, please contact CodeFactory
 * by email at info@codefactory.se, or on the web at http://www.codefactory.se/
 * You may also write to: CodeFactory AB, SE-903 47, Ume, Sweden.
 *
 * Copyright (c) 2002, 2003 Jonas Borgstrm <jonas@codefactory.se>
 * Copyright (c) 2002, 2003 Daniel Lundin   <daniel@codefactory.se>
 * Copyright (c) 2002, 2003 CodeFactory AB.  All rights reserved.
 */

#ifndef __RR_MESSAGE_H__
#define __RR_MESSAGE_H__

typedef struct _RRMessage RRMessage;
typedef struct _RRMessagePriv RRMessagePriv;
typedef struct _RRMessageClass RRMessageClass;

#include <librr/rr-channel.h>
#include <librr/rr-frame.h>

G_BEGIN_DECLS

#define RR_TYPE_MESSAGE (rr_message_get_type ())
#define RR_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), RR_TYPE_MESSAGE, RRMessage))
#define RR_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RR_TYPE_MESSAGE, RRMessageClass))
#define RR_IS_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), RR_TYPE_MESSAGE))
#define RR_IS_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RR_TYPE_MESSAGE))
#define RR_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RR_TYPE_MESSAGE, RRMessageClass))

struct _RRMessage {
	GObject        parent_object;
	gint32         msgno;
	gint32         ansno;
	RRChannel     *channel;
	RRFrameType    type;
	RRMessagePriv *priv;
};

struct _RRMessageClass {
	GObjectClass parent_class;

	RRFrame *(* get_frame)     (RRMessage *message, gsize max_size);
	gboolean (* process_frame) (RRMessage *message, RRFrame *frame, 
				    GError **error);
	/* reserved for future use */
	void (* rr_padding1)  (void);
	void (* rr_padding2)  (void);
	void (* rr_padding3)  (void);
	void (* rr_padding4)  (void);
	void (* rr_padding5)  (void);
	void (* rr_padding6)  (void);
	void (* rr_padding7)  (void);
	void (* rr_padding8)  (void);
	void (* rr_padding9)  (void);
	void (* rr_padding10) (void);
};

GType      rr_message_get_type      (void);

void       rr_message_set_aggregate (RRMessage *message, gboolean aggregate);
gboolean   rr_message_get_aggregate (RRMessage *message);

RRFrame   *rr_message_get_frame     (RRMessage *message, gsize max_size);

gboolean   rr_message_process_frame (RRMessage *message, RRFrame *frame, 
				     GError **error);

void       rr_message_set_channel   (RRMessage *message, RRChannel *channel);
RRChannel *rr_message_get_channel   (RRMessage *message);

G_END_DECLS

#endif /* __RR_MESSAGE_H__ */
