/*-
 * $Id: rr-filterstack.h,v 1.4 2003/02/05 09:03:25 jonas Exp $
 *
 * See the file LICENSE for redistribution information. 
 * If you have not received a copy of the license, please contact CodeFactory
 * by email at info@codefactory.se, or on the web at http://www.codefactory.se/
 * You may also write to: CodeFactory AB, SE-903 47, Ume, Sweden.
 *
 * Copyright (c) 2002 Jonas Borgstrm <jonas@codefactory.se>
 * Copyright (c) 2002 Daniel Lundin   <daniel@codefactory.se>
 * Copyright (c) 2002 CodeFactory AB.  All rights reserved.
 */

#ifndef __RR_FILTERSTACK_H__
#define __RR_FILTERSTACK_H__

typedef struct _RRFilterStack RRFilterStack;

#include <glib-object.h>
#include <librr/rr-filter.h>

typedef GIOStatus  (*RRReaderFunc) (guint8 *data, gsize len, 
				    gsize *read, gpointer user_data,
				    RRFilterStack *stack, GError **error);
typedef GIOStatus  (*RRWriterFunc) (guint8 *data, gsize len, 
				    gsize *written, gpointer user_data,
				    RRFilterStack *stack, GError **error);
G_BEGIN_DECLS

RRFilterStack *rr_filterstack_new        (void);
void           rr_filterstack_free       (RRFilterStack *stack);

GIOStatus      rr_filterstack_read       (RRFilterStack *stack, 
					  guint8 *data, 
					  gsize len, gsize *read, 
					  GError **error);

GIOStatus      rr_filterstack_write      (RRFilterStack *stack, 
					  guint8 *data, 
					  gsize len, gsize *written, 
					  GError **error);


void           rr_filterstack_push       (RRFilterStack *stack, 
					  RRFilter *filter);

GIOStatus      rr_filterstack_read_next  (GSList *stack, guint8 *data, 
					  gsize len, gsize *read, 
					  GError **error);

GIOStatus      rr_filterstack_write_next (GSList *next, guint8 *data, 
					  gsize len, gsize *written, 
					  GError **error);

G_END_DECLS

#endif /* __RR_FILTERSTACK_H__ */
